; boomski.asm  Com file  THIS IS REALLY COOL !!
;  the particle kaboomski thing. 275 bytes

;  this may look familiar as it was entered in that 256 byte xmas intro
;    compo.

;cleaned out and commented by fULG0Re

num      equ  1024      ; how many particles to blow up.
timer    equ  430       ; (orig 230) after how many cycles shall we explode
                        ; something.

fpd      equ  4         ; where in the integer is our fixed point dot.

addon    equ  64        ; a direction addon.  (see the random stuff)

grav     equ  1         ; gravity.

code    segment para public 'code'
                assume cs:code, ds:code
                .486
                org 100h
start:

  mov al, 13h
  int 10h

  push 07000h
  pop fs                                                ; fs->buffer

  push 0a000h
  pop es                   ; es->vga

  push 06000h
  pop gs

  mov dx, 3c8h
  xor al, al
  out dx, al
  inc dx
  mov ch, 1
PalLoop:
  mov al, cl
  shr al, 2
  neg al
  out dx, al
  out dx, al
  or al, 8
  out dx, al
  loop PalLoop


; sneaky way of combining the initializaion of the particle and the
; explosion routine.  at least i thought so...
InitPart:
  push es                 ; save our es segments..

  push gs
  pop es                  ; just so we can stosw into our particle array.

  mov [count], timer      ; setup our timer variable.

  xor di, di
  mov cx, num
InitLoop:
  mov ax, (160 shl fpd)
  stosw

  mov ax, (50 shl fpd)
  stosw

  imul bp, 6e3dh
  mov ax, bp
  sar ax, 9
  stosw

  imul bp, 6e3dh
  mov ax, bp
  sar ax, 9
  stosw                 ; ax = random(64)-32

  loop InitLoop

  pop es                ; grab back our es segment


MainLoop:

  push ds               ; save ds.
  push gs               ; so we could lodsw (if we wanted to)
  pop ds                ; and i didn't, but what the

  xor si, si

  mov cx, num
PartLoop:

  mov ax, [si+4]        ; get tx.
  add [si], ax          ; x += tx

  mov ax, [si+2]        ; ax =  y
  add ax, [si+6]        ; ax += ty
  mov [si+2], ax        ; store this.

  shr ax, fpd           ; revert it back to normal.

  mov di, ax
  imul di, 320          ; di = y*320

  cmp al, 199           ; is particle-y above ymax?
  ja Fucked             ; no, change tx&ty then.
  cmp al, 1             ; is particle-y above ymin?
  ja Fine               ; yes?  then it's cool. check x-boundry.
Fucked:
  neg word ptr [si+6]    ; ty = -ty
  sar word ptr [si+6], 1 ; ty = (-ty)/2

  sar word ptr [si+4], 2 ; tx = tx / 4
  mov ax, [si]           ; ax = x
  shr ax, fpd            ; revert back to normal.
  jmp Bonzai             ; jmp straight to the draw bit, no need to test
                         ; anything else

Fine:

  mov ax, [si]           ; ax = x
  shr ax, fpd            ; revert back to normal.

  cmp ax, 319            ; is the particle-x above xmax?
  ja FuckedAgain         ; no, change tx&ty then.
  cmp ax, 1              ; is particle-x above xmin?
  ja FineAgain           ; yes? wahoo.  then just add grav.

FuckedAgain:
  neg word ptr [si+4]    ; tx = -tx
  sar word ptr [si+4], 1 ; tx = (-tx)/2

  sar word ptr [si+6], 2 ; ty = ty / 4
  jmp Bonzai             ; don't add grav.

FineAgain:
  add word ptr [si+6], grav   ; add grav.

Bonzai:

  add di, ax             ; ax = xpos. (not the best way to do this, but
                         ;  it works.

  add si, 8              ; si points to the next particle.

  mov al, 254            ; make the colour a max so that the blur looks
                         ;  allright.
  mov fs:[di], al        ; fs points to our temp buffer.

  loop PartLoop

  push fs
  pop ds                 ; ds = fs = our temp buffer

  xor di, di
  mov cx, 64000
BlurLoop:
  xor dx, dx
  mov dl, [di-1]         ; pixel left.
  mov ax, dx
  mov dl, [di+1]         ; + pixel right.
  add ax, dx
  mov dl, [di-320]       ; + pixel above.
  add ax, dx
  mov dl, [di+320]       ; + pixel below
  add ax, dx

  shr ax, 2              ; /2 = blur of the buffer.

  jz NoCool              ; as shr sets the zero flag, we can
  dec al                 ; avoid a loop around when we cool the blur
NoCool:                  ; a bit.  (looks a bit nicer)

  mov [di], al           ; whack the new pixel back in our buffer.
  inc di
  loop BlurLoop


  xor si, si
  xor di, di
  mov cx, 16000
  rep movsd              ; whack the buffer.

  pop ds

  dec [count]            ; is it time to reinit the explosion?
  jz InitPart            ; yes?  cool, jump to PartInit.

  in al, 60h
  cmp al, 1
  jne MainLoop           ; check for esc.

  mov al, 3
  int 10h                ; set text mode.

  ret

count dw  ?              ; our variable for the timer.

ends code
end start
